#####
# BFF Test File
#
# This file demonstrates the usage of the BFF tool.
#
# For each of the following types, a field is defined and the
# output is checked.
#  - basic types
#  - arrays of basic types
#  - structs
#  - objects
#  - arrays of structs and objects
#  - dynamic arrays
#  - pointers to objects
#  - raw fields
####

library_prefix bt
output_source "test.c"
output_header "test.h"
magic  "TESTFILE1!!"

struct structest
  field Aflo array(4,9) flo32
end

object basictest
  field a8    int8
  field b8    unt8
  field a16   int16
  field b16   unt16
  field a32   int32
  field b32   unt32
  field a64   int64
  field b64   unt64

  field s8    str8
  field s16   str16
  field s32   str32

  field fs    flo32
  field fd    flo64
end

object fieldtest
  field Aint  array(3,4) int32
  field Dint  array(*)   int32
  field Aobj  array(8,9,10) basictest
  field Dobj  array(*) basictest
  field Astr  array(2,5) structest
  field Dstr  array(*) structest
  field Achr  array(10,12) str8
  field Dchr  array(*) str16
  field Pobj  ptr basictest
  field Sub   basictest
end

